﻿'El Namespace System.Data.SqlClient es necesario para la gestión de datos
'El Namespace System.Configuration es necesario para administrar el app.config
Imports System.Data.SqlClient
Imports System.Configuration
Public Class Form1
    'Variable privada para determinar si un elemento es para edición
    'o para ingresar
    Private ElementoNuevo As Boolean = False
    'Variable privada para cargar las sentencias SQL por todo el formulario
    Private cSQL As String
    'Instanciacion de la clase Datos del Namespace Datos.miEmpresa.GestionDatos
    Private tmpDatos As New Datos.miEmpresa.GestionDatos.Datos
    'Region definida para realizar las cargas y enlaces de datos.
#Region "CargarInformacion"
    'Cargar todos los paises de la tabla tbPaises o
    'el país del proveedor activo.
    Sub CargarPaisProveedor(ByVal TipoConsulta$)
        Dim strProv = ""
        If TipoConsulta = "Todos" Then
            strProv = "Select *From tbPaises"
        Else
            strProv = "SELECT tbPaises.IdPais, tbPaises.NombrePais " & _
                      "FROM tbPaises INNER JOIN " & _
                      "tbProveedores ON tbPaises.IdPais = tbProveedores.IdPais And tbProveedores.IdProveedor='" & txtIdProveedor.Text & "'"
        End If
        Dim datAdapter As New SqlClient.SqlDataAdapter(strProv, conn)
        Dim dstProv As New DataSet
        datAdapter.Fill(dstProv)
        cmbPaises.DataSource = dstProv.Tables(0)
        cmbPaises.DisplayMember = "NombrePais"
        cmbPaises.ValueMember = "IdPais"
    End Sub
    'Enlaza el control con los campos del formulario
    Sub Enlazar()
        txtIdProveedor.DataBindings.Add("Text", ds.Tables("Proveedores"), "IdProveedor")
        txtNombre.DataBindings.Add("Text", ds.Tables("Proveedores"), "Nombre")
        txtApellidos.DataBindings.Add("Text", ds.Tables("Proveedores"), "Apellidos")
        txtDireccion.DataBindings.Add("Text", ds.Tables("Proveedores"), "Direccion")
        txtTelefono.DataBindings.Add("Text", ds.Tables("Proveedores"), "Telefono")
    End Sub
    'Carga todos los proveedores de tbProveedores en un DataSet
    Sub Cargar_Proveedores()
        cSQL = "Select *From tbProveedores"
        Carga_DST_Enlazado(cSQL, "Proveedores")
    End Sub
    'Carga el DataSet de nombre Proveedores
    Sub Carga_DST_Enlazado(ByVal cadSQL$, ByVal TB As String)
        Try
            da.SelectCommand = New SqlCommand(cadSQL, conn)
            Dim objCommandBuilder As SqlCommandBuilder = New SqlCommandBuilder(da)
            If conn.State = ConnectionState.Closed Then conn.Open()
            da.Fill(ds, TB)
            If conn.State = ConnectionState.Open Then conn.Close()
            cm = Me.BindingContext(ds.Tables(TB))
            cm.Position = 0
            dr = ds.Tables("Proveedores").Rows(cm.Position)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
    Sub ProcesoInicial()
        Cargar_Proveedores()
        Enlazar()
        CargarPaisProveedor("Todos")
        BloquearCampos()
        Me.MenuGenerico1.Permitir_Editar = False
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ProcesoInicial()
    End Sub
    Sub BuscarProveedor()
        cm.Position = 0
        Dim encontrado As Boolean = False
        For Each DR As DataRow In ds.Tables("Proveedores").Rows
            If Trim(DR.Item(0).ToString) = Trim(Me.MenuGenerico1.Valor_del_Textbox) Then
                txtIdProveedor.Text = DR.Item(0).ToString
                txtNombre.Text = DR.Item(1).ToString
                encontrado = True

                Exit For
            End If
            cm.Position += 1
        Next
        If encontrado = False Then
            MsgBox("El registro No se encuentra", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, "Resultado de la búsqueda")
        End If
    End Sub
#End Region
    'Region que contiene los procedimientos de pantalla y accionar del menú
#Region "FormateoCamposPantalla"
    Sub BloquearCampos()
        Me.txtIdProveedor.ReadOnly = True
        Me.txtNombre.ReadOnly = True
        Me.txtApellidos.ReadOnly = True
        Me.txtDireccion.ReadOnly = True
        Me.txtTelefono.ReadOnly = True
        Me.cmbPaises.Enabled = False
    End Sub
    Sub DesBloquearCampos()
        Me.txtNombre.ReadOnly = False
        Me.txtApellidos.ReadOnly = False
        Me.txtDireccion.ReadOnly = False
        Me.txtTelefono.ReadOnly = False
        Me.cmbPaises.Enabled = True
    End Sub
    Sub Limpiar()
        For Each miObjeto As Object In Form1.ActiveForm.Controls
            'Valido si miObjeto es de tipo TextBox.  Si es asi
            'entonces lo dejo en blanco.
            If TypeOf miObjeto Is TextBox Then
                miObjeto.Text = ""
            End If
        Next
    End Sub
    Private Sub MenuGenerico1_BarraHaceClick(ByVal Boton As String) Handles MenuGenerico1.BarraHaceClick
        Select Case Boton
            Case "Nuevo"
                ElementoNuevo = True
                Limpiar()
                DesBloquearCampos()
                Me.txtIdProveedor.ReadOnly = False
                txtIdProveedor.Focus()
                CargarPaisProveedor("Todos")
            Case "Guardar"
                GuardarModificar()
                BloquearCampos()
                ds.Tables("Proveedores").Clear()
                Cargar_Proveedores()
                CargarPaisProveedor("Individual")
            Case "Borrar"
                Dim mensaje = "¿Desea eliminar al proveedor " & txtNombre.Text & "?"
                If MsgBox(mensaje, MsgBoxStyle.YesNo + MsgBoxStyle.Critical) = MsgBoxResult.Yes Then
                    cSQL = "Delete From tbProveedores Where IDProveedor = '" & txtIdProveedor.Text & "'"
                    If tmpDatos.Procesar(cSQL, conn) = True Then
                        MsgBox("El registro fue exitosamente eliminado de la base de datos", MsgBoxStyle.Information)
                    Else
                        MsgBox("El registro no fue eliminado de la base de datos", MsgBoxStyle.Information)
                    End If
                    ds.Tables("Proveedores").Clear()
                    Cargar_Proveedores()
                End If
            Case "Cancelar"
                BloquearCampos()
                cm.CancelCurrentEdit()
                Me.MenuGenerico1.Permitir_Editar = False
            Case "Editar"
                DesBloquearCampos()
                Me.MenuGenerico1.Editar_Elemento()
                Me.txtIdProveedor.ReadOnly = True
                txtNombre.Focus()
                ElementoNuevo = False
                CargarPaisProveedor("Todos")
            Case "Primero"
                cm.Position = 0
                CargarPaisProveedor("Individual")
            Case "Anterior"
                cm.Position -= 1
                CargarPaisProveedor("Individual")
            Case "Siguiente"
                cm.Position += 1
                CargarPaisProveedor("Individual")
            Case "Ultimo"
                cm.Position = cm.Count - 1
                CargarPaisProveedor("Individual")
            Case "Buscar"
                BuscarProveedor()
                CargarPaisProveedor("Individual")
            Case "Regresar"
                Me.Dispose()
                forma.Show()
        End Select
    End Sub
    'Configura el accionar del menú
    Private Sub GuardarModificar()
        Select Case ElementoNuevo
            Case True
                cSQL = "Insert Into tbProveedores (IdProveedor,Nombre,Apellidos,Direccion,Telefono,IdPais) " & _
                " Values('" & txtIdProveedor.Text & "','" & txtNombre.Text & "','" & txtApellidos.Text & _
                "','" & txtDireccion.Text & "','" & txtTelefono.Text & "','" & Trim(cmbPaises.SelectedValue) & "')"
            Case False
                cSQL = "Update tbProveedores Set Nombre = '" & txtNombre.Text & _
                 "', Apellidos ='" & txtApellidos.Text & _
                 "', Direccion ='" & txtDireccion.Text & _
                 "', IdPais ='" & Trim(cmbPaises.SelectedValue) & _
                 "' Where IdProveedor='" & Trim(txtIdProveedor.Text) & "'"
        End Select
        If tmpDatos.Procesar(cSQL, conn) = True Then
            MsgBox("La información fue procesada exitosamente!", MsgBoxStyle.Information)
        Else
            MsgBox("Se ha producido el error !" & tmpDatos.Datos_Mensajes, MsgBoxStyle.Information)
        End If
    End Sub
#End Region


    Private Sub MenuGenerico1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuGenerico1.Load

    End Sub
End Class
