﻿Public Class Form2
    'Administra todos los objetos Binding enlazados al mismo origen y miembro de datos
    Dim WithEvents bmb As BindingManagerBase
    'Procedimiento para cargar el dataset con los datos de paises y proveedores
    Sub CargarDataSet(ByVal strSQLPais$, ByVal strSQLProv$)
        Try
            'verificar sila conexión esta cerrada y si es asi, la abre
            If conn.State = ConnectionState.Closed Then conn.Open()
            'crea el adaptador de datos para paises según la sentencia SQL y la conexión
            Dim objAdaptadorPaises As New SqlClient.SqlDataAdapter _
                           (strSQLPais, conn)
            'crea el adaptar de datos para proveedores segun la sentencia sQL y la conexión
            Dim objAdaptadorProveedores As New SqlClient.SqlDataAdapter _
                                       (strSQLProv, conn)
            'carga el DataSet Paises
            objAdaptadorPaises.Fill(ds, "Paises")
            'carga el DataSet Proveedores
            objAdaptadorProveedores.Fill(ds, "Proveedores")
            'crea un campo común (relación) en el DataSet para Países y Proveedores
            ds.Relations.Add("PaisesProveedores", _
                        ds.Tables("Paises").Columns("idPais"), _
                        ds.Tables("Proveedores").Columns("idPais"))
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
    Sub PosicionRegistro()
        'visualiza el registro actual en el DataSet
        Label3.Text = "Posición del Registro " & bmb.Position & " del DataSet"
    End Sub
    Sub DataBinding()
        Try
            'carga en el textbox txtIdPais el campo texto del dataset ds
            txtIdPais.DataBindings.Add("Text", ds, "Paises.IdPais")
            txtNombrePais.DataBindings.Add("Text", ds, "Paises.NombrePais")
            'configura el origen de datos del DataGridView1 con la información del
            'DataSet ds y la relación establecida en el mismo con PaisesProveedores
            With DataGridView1
                .DataSource = ds
                .DataMember = "Paises.PaisesProveedores"
            End With
            'el contexto del dataset se almacena en bmb (para navegación)
            bmb = Me.BindingContext(ds, "Paises")
            bmb.Position = bmb.Count
            bmb.Position = 0
            PosicionRegistro()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Form2_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'se declaran y cargan las variables que contendrán sentencias SQL
        Dim cadSQL1, cadSQL2 As String
        cadSQL1 = "Select *From tbPaises"
        cadSQL2 = "Select Nombre, Apellidos, Direccion, Telefono, Idpais  From tbProveedores"
        Try
            'Se envia a ejecutar la carga del DataSet con las dos cadenas SQL.
            CargarDataSet(cadSQL1, cadSQL2)
            'Se llama a la vinculación de datos
            DataBinding()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub btnPrimero_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrimero.Click
        bmb.Position = 0
        PosicionRegistro()
    End Sub

    Private Sub btnAnterior_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAnterior.Click
        bmb.Position -= 1
        PosicionRegistro()
    End Sub

    Private Sub btnSiguiente_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSiguiente.Click
        bmb.Position += 1
        PosicionRegistro()
    End Sub

    Private Sub btnUltimo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUltimo.Click
        bmb.Position = bmb.Count - 1
        PosicionRegistro()
    End Sub

    Private Sub DataGridView1_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellClick
        MsgBox(DataGridView1.CurrentRow.Cells(0).Value)
    End Sub

    Private Sub btnImprimir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnImprimir.Click
        'crea una instancia del formulario frmReportes
        Dim frm As New frmReportes
        'a la variable global forma (que es de tipo WinForms) se le asigna el formulario actual
        forma = Me
        'Oculta el formulario actual
        Me.Hide()
        'Obtiene la ruta de los reportes de la variable global rutaReportes
        'esta variable global la deberás declarar en el módulo global
        'aunque sería buena práctica incluir la ruta en el app.config
        frm.CrystalReportViewer1.ReportSource = rutaReportes & "rpProveedoresPais.rpt"
        'construye la consulta de selección para el visor del informe.
        frm.CrystalReportViewer1.SelectionFormula = "{tbProveedores.IdPais}= '" & txtIdPais.Text & " '"
        frm.Show()
    End Sub
End Class
