﻿Imports System.Data.SqlClient
Public Class Form1
    Dim strConn = "Data Source=EGOMEZ\EGOMEZ;" _
                    & "Initial Catalog=dbInventario;" _
                    & "Integrated Security=True"


    Private conn As New SqlConnection(strConn)
    Dim strProveedores = "SELECT tbProveedores.IdProveedor, tbProveedores.Nombre, " & _
                         "tbProveedores.Apellidos, tbProveedores.Direccion," & _
                         "tbProveedores.Telefono,tbProveedores.IdPais,tbPaises.IdPais " & _
                         " AS Pais, dbo.tbPaises.NombrePais FROM tbPaises INNER JOIN " & _
                         "tbProveedores ON tbPaises.IdPais = tbProveedores.IdPais"
    Private daProveedores As New SqlDataAdapter(strProveedores, conn)
    Private dsProveedores As New DataSet
    Private cmProveedores As CurrencyManager
    Private Sub BindTextBox()
        'Enlaza los controles TextBox a los campos de la tabla Proveedores
        txtIdProveedor.DataBindings.Add("Text", dsProveedores.Tables("Proveedores"), "IdProveedor")
        txtNombre.DataBindings.Add("Text", dsProveedores.Tables("Proveedores"), "Nombre")
        txtApellidos.DataBindings.Add("Text", dsProveedores.Tables("Proveedores"), "Apellidos")
        txtDireccion.DataBindings.Add("Text", dsProveedores.Tables("Proveedores"), "Direccion")
        txtTelefono.DataBindings.Add("Text", dsProveedores.Tables("Proveedores"), "Telefono")
        cmbPaises.DataBindings.Add("Text", dsProveedores.Tables("Proveedores"), "NombrePais")
    End Sub
    Private Sub HabilitarBotones(ByVal sender As System.Object, ByVal e As System.EventArgs) _
Handles MyBase.Load
        'Habilita los botones luego de actualizar o cancelar
        'cualquier llamado a Agregar, actualizar o eliminar registros
        btnNuevo.Enabled = True
        btnEliminar.Enabled = True
        btnModificar.Enabled = True
        btnBuscar.Enabled = True
        btnAceptar.Enabled = False
        btnCancelar.Enabled = False
        BloquearTextBox(sender, e)
    End Sub
    Private Sub DesHabilitarBotones(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles btnNuevo.Click, btnModificar.Click
        'Deshabilita los botones luego de actualizar o cancelar
        'cualquier llamado a Agregar, actualizar o eliminar registros
        btnNuevo.Enabled = False
        btnEliminar.Enabled = False
        btnModificar.Enabled = False
        btnBuscar.Enabled = False
        btnAceptar.Enabled = True
        btnCancelar.Enabled = True
    End Sub

    Private Sub BloquearTextBox(ByVal sender As System.Object, ByVal e As System.EventArgs) _
Handles MyBase.Load
        'Deshabilita los objetos textbox luego de actualizar o cancelar
        'cualquier llamado a Agregar, actualizar o eliminar registros
        Dim FormControl As System.Windows.Forms.Control
        For Each FormControl In Me.Controls
            If FormControl.GetType.ToString = "System.Windows.Forms.TextBox" Then
                FormControl.Enabled = False
            End If
        Next
    End Sub

    Private Sub DesBloquearTextBox(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'Habilita los objetos textbox luego de actualizar o cancelar
        'cualquier llamado a Agregar, actualizar o eliminar registros
        Dim FormControl As System.Windows.Forms.Control
        For Each FormControl In Me.Controls
            If FormControl.GetType.ToString = "System.Windows.Forms.TextBox" Then
                FormControl.Enabled = True
            End If
        Next
    End Sub
    Private Sub Navegar(ByVal sender As System.Object, ByVal e As System.EventArgs)
        lblNavegacion.Text = "Proveedor " & cmProveedores.Position + 1 & " de un total de " & cmProveedores.Count
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Llena el DataSet con la tabla Proveedores
        daProveedores.Fill(dsProveedores, "Proveedores")
        'Enlaza el objeto CurrencyManager al DataSet dsProveedores, el cual
        'consume los datos de la tabla Proveedores
        cmProveedores = Me.BindingContext(dsProveedores.Tables("Proveedores"))

        cmProveedores.Position = 0
        'Llama al procedimiento BindTextBox para enlazar los objetos TextBox a 
        'los campos de la tabla Proveedores
        BindTextBox()
        'Llama al procedimiento Navegar enviandole los parámetros sender y e
        'pertenecimientes al formulario actual
        Navegar(sender, e)
    End Sub

    Private Sub btnNuevo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNuevo.Click
        Try
            'Método que sirve para cancelar las modificaciones en los registros
            'y habilitar la posibilidad de ingresar uno nuevo
            cmProveedores.EndCurrentEdit()
            'Se crea un nuevo registro utilizando el método AddNew() 
            'que es código nativo de Visual Basic
            cmProveedores.AddNew()
        Catch ex As System.Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub btnEliminar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEliminar.Click
        Dim msg$
        msg = "Esta a punto de elminar el registro " & txtNombre.Text & _
                    txtApellidos.Text & vbCrLf
        msg = msg & "Dicha acción es irrecuperable ¿Desea eliminarlo de todos modos?"
        If MsgBox(msg, MsgBoxStyle.YesNo + MsgBoxStyle.Critical, "Eliminación de Registro") = _
                                               MsgBoxResult.Yes Then
            If (cmProveedores.Count > 0) Then
                cmProveedores.RemoveAt(cmProveedores.Position)
                'La operación de eliminación borra el registro
                'en el DataSet
                'La instrucción Update, por su parte lo hace en la base de datos
                btnAceptar_Click(sender, e)
            Else
                MsgBox("No ningún registro para eliminar", MsgBoxStyle.Information, "Confirmación" & _
                                      MessageBoxIcon.Exclamation)
            End If
        Else
            MsgBox("No se eliminó ningún registro", MsgBoxStyle.Information, "Confirmación" & _
                                                MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub btnModificar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnModificar.Click

    End Sub

    Private Sub btnAceptar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAceptar.Click
        Dim cbProveedores As New SqlCommandBuilder(daProveedores)
        Try
            cmProveedores.EndCurrentEdit()
            'Actualiza la tabla clientes

            daProveedores.Update(dsProveedores, "Proveedores")
            dsProveedores.AcceptChanges()
        Catch ex As Exception
            MsgBox(ex.InnerException)
        End Try
        HabilitarBotones(sender, e)
    End Sub

    Private Sub btnBuscar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBuscar.Click
        Dim strBusca As String
        strBusca = InputBox("Digite el código del Cliente : ", "Búsqueda de Proveedor")
        If strBusca <> "" Then
            Dim VistaProveedores As DataView = New DataView(dsProveedores.Tables("Proveedores"), "", _
                                        "IdProveedor", DataViewRowState.CurrentRows)
            Dim rowIndex As Integer = VistaProveedores.Find(strBusca)
            If rowIndex = -1 Then
                MessageBox.Show("No se encontró ningún registro de Proveedor, según el código " & strBusca, _
   "Búsqueda", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                cmProveedores.Position = rowIndex
            End If
        End If
    End Sub

    Private Sub btnCancelar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancelar.Click
        cmProveedores.CancelCurrentEdit()
        HabilitarBotones(sender, e)
    End Sub

    Private Sub btnSiguiente_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSiguiente.Click
        cmProveedores.Position += 1
        Navegar(sender, e)
    End Sub

    Private Sub btnAnte_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAnte.Click
        cmProveedores.Position -= 1
        Navegar(sender, e)
    End Sub

    Private Sub btnPrimero_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrimero.Click
        cmProveedores.Position = 0
        Navegar(sender, e)
    End Sub

    Private Sub btnUltimo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUltimo.Click
        cmProveedores.Position = cmProveedores.Count - 1
        Navegar(sender, e)
    End Sub

    Private Sub btnSalir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSalir.Click
        End
    End Sub
End Class
