﻿'Objetivo: Esta clase, permite el manejo de las operaciones básicas con las bases de datos
'          Estas operaciones son:
'                               1- Consultas a las Tablas.
'                               2- Ingreso, Modificacion y Borrado de Datos.
'          Para la utilización de esta clase, se debe pasar por medio de un parametro
'          la conexión a la base de datos que vamos a utilizar (puede ser de cualquier
'          base de datos.
Imports System.Data.SqlClient 'permite las conexion con el servidor de base de datos
Namespace miEmpresa.GestionDatos
    Public Class Datos
        Private C_Mensajes$ 'Para los mensajes que devuelva la clase

        Public Function BUSCAR_DATOS(ByVal sSQL$, ByVal C_Conexion As SqlClient.SqlConnection) As SqlClient.SqlDataReader
            'Objetivo: Esta función, le permite a la clase, realizar la búsqueda de datos dentro
            '          de la BD y así devolverlos en un datareader a la aplicacion.
            '          Recibe como parámetro una sentencia SQL, del tipo SELECT,  devuelve un 
            '          datareader con los elementos encontrados.
            '          en C_Conexion recibe la conexion de parte de la aplicación que la invoca 
            Try

                Dim objcmd As New SqlClient.SqlCommand(sSQL, C_Conexion)
                Return objcmd.ExecuteReader
            Catch ex As Exception
                MsgBox(ex.Message())
                Return Nothing
            End Try
        End Function
        Public Function Procesar(ByVal sSQL$, ByVal C_Conexion As SqlClient.SqlConnection) As Boolean
            'Objetivo: Esta función, le permite a la clase, realizar operaciones de INSERCION, ACTUALIZACION
            '          y BORRADO de datos en la BD.
            '          Recibe como parámetro una sentencia SQL, de los tipos INSERT, UPDATE, DELETE
            '          y retorna un valor TRUE si se realiza o FALSE si falla.
            '          en C_Conexion recibe la conexion de parte de la aplicación que la invoca 
            Dim trans As SqlTransaction = Nothing
            Try
                If C_Conexion.State = ConnectionState.Closed Then C_Conexion.Open()
                trans = C_Conexion.BeginTransaction
                Dim objcmd As New SqlClient.SqlCommand(sSQL, C_Conexion)
                objcmd.Transaction = trans
                If objcmd.ExecuteNonQuery() >= 0 Then trans.Commit()
                C_Conexion.Close()
                Return True
            Catch ex As Exception
                C_Mensajes = "Excepción!!!" & ex.Message & vbCrLf _
                    & "Nº Error: " & Err.Number & vbCrLf _
                    & "Detalle: " & Err.Description
                trans.Rollback()
                C_Conexion.Close()
                Return False
            End Try
        End Function
        Public ReadOnly Property Datos_Mensajes() As String
            'Objetivo: Esta propiedad, envia a la aplicación los mensajes que remita
            '          esta clase.
            Get
                Datos_Mensajes = C_Mensajes
            End Get
        End Property
    End Class
End Namespace

